import math
from distance import distance

##A node containing only the h and v variables
##h is not used at the moment, while v is used
##for rebuilding.
class gbtnode:

##Constructor. Sets h and v to 0.
    def __init__(self):
        self.h = 0
        self.v = 0


##A framework for GBT-trees. Ended up including
##far less than expected because difficulty in
##adapting trees in a general way.
##Takes care of total and partial rebuidling.
class gbt:

##Constructor. Initializes some variables.
    def __init__(self, dtype):
        self.d = 0
        self.b = 1
        self.c = 2.0
        self.dist = distance(dtype)
        self.totalRebuilds = 0
        self.partialRebuilds = 0
        self.totalDelete = 0
        self.doRebuild = 1

##Updates the deleteparameters
    def updateDelete(self):
        self.d += 1
        self.totalDelete += 1

##Checks if the tree should be rebuilt by using the criteria
##given by Andersson. If total rebuild, it just calls
##rebuild on the tree with the root as the input.
##If partial it calls findRebuilding.
##Insertpath is the path to the inserted node, while
##modifier says how much each node should count.
    def checkRebuild(self, insertPath, modifier):
        if self.doRebuild:
            x = (pow(2, self.b/self.c)-1)*self.root.v
            if self.d >= x:
                print "Rebuilding everything"
                self.root = self.rebuildTree(self.root)
                self.d = 0
                self.totalRebuilds += 1
            else:
                number = int(self.c * math.log(self.root.v + self.d, 2)) + 1
                if len(insertPath)*modifier > number:
                    print "Rebuild partial"
                    self.findRebuilding(insertPath, modifier)
                    self.partialRebuilds += 1

##Finds out where in the insertpath the rebuiling should
##happen by traversing backwards until the criteria is
##reaches. When that happens, a rebuilding happens with
##the node as the root, and the new root replaces the old
##node.
    def findRebuilding(self, insertPath, modifier):
        nn = len(insertPath)
        rebuilt = False
        while not rebuilt:
            number = int(self.c * math.log(insertPath[nn-1].v, 2)) + 1
            length = (len(insertPath)-nn)*modifier
            if length > number:
                if nn < 1:
                    self.root = self.rebuildTree(insertPath[0])
                else:
                    b = insertPath[nn-1].replaceChild(insertPath[nn], self.rebuildTree(insertPath[nn]))
                rebuilt = True
            nn -= 1

