import math

##Class for computing the distance between objects
class distance:

    def __init__(self, dtype):
        self.dtype = dtype
        self.distanceComputations = 0

##choses which function to use
    def distance(self, o1, o2):
        self.distanceComputations += 1
        if self.dtype == 0:
            return self.euclidian(o1, o2)
        elif self.dtype == 1:
            return self.editDistance(o1, o2)
        print "wrong distance type"
        return 0

##The edit function. Dynamic programming algorithm
##that finds the minimum number of moves needed to
##change one string into another. Uses weitght 1 for every operation
    def editDistance(self, s, t):
        n = 0
        m = 0
        i = 0
        j = 0
        si = ' '
        tj = ' '
        cost = 0

        n = len(s)
        m = len(t)

        if n == 0:
            return m
        if m == 0:
            return n

        d = list()
        for i in range(0, n+1):
            d.append([0]*(m+1))

        for i in range(0, (n+1)):
            d[i][0] = i
        for j in range(0, (m+1)):
            d[0][j] = j

        for i in range(1, (n+1)):
            si = s[i-1]
            for j in range(1, (m+1)):
                tj = t[j-1]
                if si == tj:
                    cost = 0
                else:
                    cost = 1
                d[i][j] = self.minimum(d[i-1][j]+1, d[i][j-1]+1, d[i-1][j-1] + cost)
        return d[n][m]

##Just finds the minimum of three objects
    def minimum(self, a, b, c):
        mi = a
        if b < mi:
            mi = b
        if c < mi:
            mi = c
        return mi

##Computes the euclidian distance between two objects
    def euclidian(self, o1, o2):
        if o1 == None or o2 == None:
            return 0
        po1 = o1
        po2 = o2
        distance = 0
        for i in range(len(po1)):
            distance += (po1[i] - po2[i])**2
        return math.sqrt(distance)
